{ +--------------------------------------------------------------------------+ }
{ | Tubes2 for DOS 0.2 Open edition * Electron tube catalog                  | }
{ | Copyright (C) 2016-2017 Pozsar Zsolt <info@pozsarzs.hu>                  | }
{ | uconfig.pas                                                              | }
{ | configuration file handler                                               | }
{ +--------------------------------------------------------------------------+ }

{
   This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by the
 Free Software Foundation, either version 3 of the License, or (at your
 option) any later version.

   This program is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

   You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit uconfig;
interface
uses
  dos,
  ucommon;
var
  b: byte;
  esnd: boolean;
  exepath: string;
  fpal: string[11];
  lng: string[2];
  pgdr: boolean;
  s, ss: string;
  textfile: text;
  picviewer: string;

function loadcfgfile(filename: string): boolean;
procedure setexepath;

implementation

//-- load configuration file ---------------------------------------------------
function loadcfgfile(filename: string): boolean;
begin
  pgdr:=true;
  esnd:=true;
  fpal:='';
  picviewer:='';
  assign(textfile,filename);
  {$I-}
  reset(textfile);
  {$I+}
  if ioresult=0 then
  begin
    repeat
      readln(textfile,s);
      s:=rmchr1(s);
      s:=rmchr2(s);
      ss:=s[1]+s[2]+s[3];
      if ss='PV=' then
        for b:=4 to length(s) do picviewer:=picviewer+s[b];
      if ss='FP=' then
        for b:=4 to length(s) do fpal:=fpal+s[b];
      if ss='LN=' then
        lng:=s[4]+s[5];
      if ss='PG=' then
        if s[4]+s[5]+s[6]='yes' then pgdr:=true else pgdr:=false;
      if ss='ES=' then
        if s[4]+s[5]+s[6]='yes' then esnd:=true else esnd:=false;
    until eof(textfile);
    close(textfile);
    loadcfgfile:=true;
    end
  else loadcfgfile:=false;
end;

// -- set path of executable file ----------------------------------------------
procedure setexepath;
var
  p: shortstring;
begin
  fsplit(paramstr(0),exepath,p,p);
end;

end.

