{ +--------------------------------------------------------------------------+ }
{ | Tubes2 for DOS 0.2 Open edition * Electron tube catalog                  | }
{ | Copyright (C) 2016-2017 Pozsar Zsolt <info@pozsarzs.hu>                  | }
{ | usubst.pas                                                               | }
{ | VT/M2/CV substitution                                                    | }
{ +--------------------------------------------------------------------------+ }

{
   This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by the
 Free Software Foundation, either version 3 of the License, or (at your
 option) any later version.

   This program is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

   You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

{$MODE OBJFPC}{$H+}
unit usubst;
interface
uses
  crt,
  uconfig, ucommon;
type
  indata=record
    name1: string[16];
    name2: string[16];
  end;
var
  types: array[1..5000,1..2] of string[16];                        { Type list }
  b, bb: byte;                                    { General byte type variable }
  c: char;                                        { General character variable }
  s, ss, x: string;                             { General string type variable }
  prefix: string;                                                { Type prefix }

procedure substbox(prfx: string);
procedure substcontent;
function loaddatafile: boolean;

resourcestring
  MESSAGE01 = 'CV';
  MESSAGE02 = 'M2';
  MESSAGE03 = 'VT';
  MESSAGE04 = 'CV';
  MESSAGE05 = 'M2';
  MESSAGE06 = 'VT-';
  MESSAGE07='<BackSpace> Delete  <Escape> Close';
  MESSAGE08='Type substitution';
  MESSAGE09='Close';
  MESSAGE10='Too many found.';
  MESSAGE11='Not found.';
  MESSAGE12='Error';
  MESSAGE13='Cannot open datafile.';
  MESSAGE14='<Enter> OK';
  MESSAGE15='Please, enter your search type.';

implementation

// -- Remove bad characters ----------------------------------------------------
function rembadchar(input: string): string;
begin
  x:=input;
  delete(x,2,length(x));
  if x<>'#' then
  begin
    input:=rmchr3(input);     { remove all 'empty' characters to begin of text }
    input:=rmchr2(input);                   { remove all characters after hash }
  end;
  input:=rmchr1(input);                       { remove all space and tabulator }
  rembadchar:=input;
end;

// -- Input fiesd --------------------------------------------------------------
procedure inputwin;
begin
  textbackground(button_background); textcolor(button_foreground);
  window(21+length(prefix),7,59,7);
end;

// -- Output field -------------------------------------------------------------
procedure outputwin;
begin
  textbackground(black); textcolor(lightgreen);
  window(21,9,59,17); clrscr;
end;

// -- Create box ---------------------------------------------------------------
procedure substbox(prfx: string);
begin
  prefix:=prfx;
  footer(MESSAGE07);
  textbackground(black); window(20,7,64,21); clrscr;
  textbackground(menu_background); textcolor(menu_foreground); win(18,6,62,20);
  gotoxy(4,1); write(' '+MESSAGE08+' ');
  gotoxy(4,2); write(prefix);
  line(20,62,8);
  line(20,62,18);
  textbackground(button_background); textcolor(button_foreground);
  gotoxy(36,19); writeln('[ '+MESSAGE09+' ]');
  gotoxy(21+length(prefix),7); for b:=1 to 39-length(prefix) do write(' ');
  outputwin; clrscr; writeln(MESSAGE11);
end;

// -- Load subst.dat -----------------------------------------------------------
function loaddatafile: boolean;
var
  id: indata;
  rf: file of indata;
  i: integer;

begin
  assign(rf,exepath+'..\library\subst.dat');
  {$I-}
  reset(rf);
  {$I+}
  if ioresult<>0 then loaddatafile:=false else
  begin
    i:=1;
    repeat
      read(rf,id);
      types[i,1]:=id.name1; types[i,2]:=id.name2;
      i:=i+1;
    until eof(rf);
    close(rf);
    loaddatafile:=true;
  end;
end;

// -- Search box ---------------------------------------------------------------
procedure substcontent;
var
  TOC: array[1..20] Of string;
  items: itemrec;                                           { Table of content }
  messtext: messagerec;                      { Variable of messages procedures }
  i: integer;
  c: char;
  st: string[12];
  ct: byte;
  xp, yp: byte;

begin
  for b:=1 to 20 do TOC[b]:='';
    with items do
    begin
      i1:=MESSAGE01;
      i2:=MESSAGE02;
      i3:=MESSAGE03;
      i4:='';  i5:='';  i6:='';  i7:='';  i8:='';  i9:='';  i10:='';
      i11:=''; i12:=''; i13:=''; i14:=''; i15:=''; i16:=''; i17:='';
      i18:=''; i19:=''; i20:='';
    end;
    b:=menu(41,3,items);
    if b=255 then exit;
    case b of
      1: substbox(MESSAGE04);
      2: substbox(MESSAGE05);
      3: substbox(MESSAGE06);
    end;
    outputwin;
    writeln(MESSAGE15);
  st:='';
  repeat
    inputwin;
    gotoxy(xp,yp); cursoron;
    c:=readkey;
    if c=#0 then c:=readkey;
    cursoroff;

    if c=#8 then delete(st,length(st),1);
    if (c>#41) and (c<#123) then
    begin
      c:=upcase(c);
      st:=st+c;
    end;
    
    inputwin; clrscr;
    write(st); xp:=wherex; yp:=wherey;
    outputwin;
    ct:=0;
    for i:=1 to 5000 do
      if pos(prefix+st,types[i,1])>0 then
      begin
        write(' '+types[i,1]);
        gotoxy(20,wherey); writeln(types[i,2]);
        ct:=ct+1;
        if ct=9 then begin write(' '+MESSAGE10); break; end;
      end;
      if ct=0 then write(' '+MESSAGE11);
  until c=#27;
  end;
end.